#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>

/*
    2010 - Copyright by Bee <http://www.honeybeenet.altervista.org>.
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
*/

/*
    After a lot of super hard work, this application launcher is ready!!!
        and working!!!!!!!!!
*/

#define REQUIRED_ARGC 4
int main(int argc, char **argv)
{
    struct stat buf;
    char *command;
    char *commandline[] = {NULL,NULL,NULL};
    char *lockfile;
    int fd;
    int pid;
    int status;
    char syncfile[]="/tmp/gbeesu.XXXXXX";
    if(argc > REQUIRED_ARGC)
    {
        command = argv[1];                               // 1, REQUIRED_ARGC - 3
        if(strcmp(command, "gedit-beesu-plugin") == 0)
        {
            command        = argv[2];                    // 2, REQUIRED_ARGC - 2
            commandline[0] = argv[3];                    // 3, REQUIRED_ARGC - 1
            lockfile       = argv[4];                    // 4, REQUIRED_ARGC
            if(argc > (REQUIRED_ARGC + 1))
                commandline[1] = argv[REQUIRED_ARGC + 1];// 5, REQUIRED_ARGC + 1
            if(lstat(lockfile, &buf) == 0)
            {
                if(buf.st_size == 0 && S_ISREG(buf.st_mode))
                {
                    fd = mkstemp(syncfile);
                    if(fd == -1)
                        return EXIT_FAILURE;
                    close(fd);
                    pid = fork();
                    switch(pid)
                    {
                        case 0:
                            fd = open("/dev/null", O_RDWR);
                            if(fd != -1)
                            {
                                dup2(fd, 0);
                                dup2(fd, 1);
                                dup2(fd, 2);
                                close(fd);
                            }
                            signal(SIGHUP, SIG_IGN);
                            switch(fork()) // internal fork!!
                            {
                                case -1:
                                    _exit(EXIT_FAILURE);
                                    break;
                                case 0:
                                    signal(SIGHUP, SIG_IGN);
                                    unlink(syncfile);
                                    execvp(command, commandline);
                                    _exit(EXIT_FAILURE);
                                    break;
                                default:
                                    break;
                            }
                            _exit(EXIT_SUCCESS);
                            break;
                        case -1:
                            unlink(syncfile);
                            return EXIT_FAILURE;
                            break;
                        default:
                            waitpid(pid, &status, 0);
                            // Wait (max 20 seconds!!!) for the syncfile to be removed!!!
                            for(status = 0; status < 20; status++)
                            {
                                if(access(syncfile, F_OK) == 0)
                                {
                                    sleep(1);
                                }
                                else
                                {
                                    break;
                                }
                            }
                            if(access(syncfile, F_OK) == 0)
                            {
                                // Enter here on error
                                unlink(syncfile);
                            }
                            else
                            {
                                // Enter here on success!!!!!!
                                usleep(50000);
                                unlink(lockfile);
                            }
                            return EXIT_SUCCESS;
                            break;
                    }
                }
            }
        }
    }
    return EXIT_FAILURE;
}

